package edu.ntut.curtain.db;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class DBUtil {

	String dbtime;
	String dbUrl = "jdbc:mysql://localhost:3306/test";
	String dbClass = "com.mysql.jdbc.Driver";

	private static DBUtil dbUtil = new DBUtil();

	public Connection getConnection() {
		Connection conn = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			conn = DriverManager.getConnection(dbUrl+"?user=root&password=root&characterEncoding=utf-8&characterSetResults=utf8");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}

		return conn;

	}

	public static DBUtil getInstance() {
		return dbUtil;

	}

	public static void main(String args[]) {
		DBUtil util = new DBUtil();
		util.insertChild();
//		util.insertPatrol();
	} // end main

	private void insertPatrol() {
		String dbtime;
		String dbUrl = "jdbc:mysql://localhost:3306/test";
//		String dbClass = "com.mysql.jdbc.Driver";
//		String id = "1001";
//		String query = "Select * FROM teacher where id = " + id;
		// new Date();
		// String insert =
		// "insert into patrol(seq, action_name, action_time, end_time, status) values( 1, 早自習，"+
		// new Date(), new Date(), "1" +")");
		String INSERT_RECORD = "insert into patrol(action_name, action_time, end_time, status) values(?, ?, ?, ?)";

		try {

			Class.forName("com.mysql.jdbc.Driver");
			Connection conn = DriverManager
					.getConnection(dbUrl+"?user=root&password=root&characterEncoding=utf-8&characterSetResults=utf8");

			PreparedStatement pstmt = conn.prepareStatement(INSERT_RECORD);
//			pstmt.setInt(1, 3);
			pstmt.setString(1, new String("放學".getBytes("UTF8"), "UTF8"));
			java.sql.Date sqlDate = new java.sql.Date(
					new java.util.Date().getTime());
			pstmt.setDate(2, sqlDate);
			pstmt.setDate(3, sqlDate);
			pstmt.setString(4, "1");

			pstmt.executeUpdate();

			 Statement stmt = conn.createStatement();
			 ResultSet rs = stmt.executeQuery("Select * FROM patrol");
			 rs.getMetaData();
			 
			 while (rs.next()) {
			 dbtime = rs.getString(2);
			 
			 System.out.println(dbtime);
			 } // end while

			conn.close();
		} // end try

		catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

		catch (SQLException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
	}

	private void insertChild() {

		String dbtime;
		String dbUrl = "jdbc:mysql://localhost:3306/test";
		String dbClass = "com.mysql.jdbc.Driver";
		String id = "1001";
		// new Date();
		// String insert =
		// "insert into patrol(seq, action_name, action_time, end_time, status) values( 1, 早自習，"+
		// new Date(), new Date(), "1" +")");
		String INSERT_RECORD = "insert into child(id, name, address, tel_phone, mobile_phone, email, image) values(?, ?, ?, ?, ?, ?, ?)";
		FileInputStream fis;
		Connection conn = null;
		PreparedStatement psmnt = null;
		try {
			File image = new File("/home/jimchin/foresight/kid_photo.png");

			Class.forName("com.mysql.jdbc.Driver");
			conn = DriverManager
					.getConnection(dbUrl+"?user=root&password=root&characterEncoding=utf-8&characterSetResults=utf8");
			psmnt = conn.prepareStatement(INSERT_RECORD);
//			psmnt.setString(1, "5");
			psmnt.setString(1, "st1001");
			psmnt.setString(2, "jack");
			psmnt.setString(3, "台北市忠孝東路三段一號");
			psmnt.setString(4, "02-12345678");
			psmnt.setString(5, "0920-012345");
			psmnt.setString(6, "st1001@ntut.tw");

			fis = new FileInputStream(image);
//			psmnt.setString(8, getClobDataAsString(image));
			psmnt.setBinaryStream(7, fis, (int) image.length());

			/*
			 * executeUpdate() method execute specified sql query. Here this
			 * query insert data and image from specified address.
			 */
			int s = psmnt.executeUpdate();
			if (s > 0) {
				System.out.println("Uploaded successfully !");
			} else {
				System.out.println("unsucessfull to upload image.");
			}

			psmnt.executeUpdate();

			// Statement stmt = conn.createStatement();
			// ResultSet rs = stmt.executeQuery(query);
			//
			// while (rs.next()) {
			// dbtime = rs.getString(3);
			// System.out.println(dbtime);
			// } // end while

			conn.close();
		} // end try

		catch (Exception ex) {
			System.out.println("Found some error : " + ex);
		} finally {
			// close all the connections.
			try {
				conn.close();
				psmnt.close();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	private static String getClobDataAsString(File imageFile) throws Exception {
		InputStream is = null;
		try {
//			URL url = new URL(urlData);
			System.out.println("file:" + imageFile.getAbsolutePath());
//			URLConnection urlConn = url.openConnection();
//			urlConn.connect();
//			InputStream in = new FileInputStream(contentfile);
			is = new FileInputStream(imageFile);
			int BUFFER_SIZE = 1024;
			ByteArrayOutputStream output = new ByteArrayOutputStream();
			int length;
			byte[] buffer = new byte[BUFFER_SIZE];
			while ((length = is.read(buffer)) != -1) {
				output.write(buffer, 0, length);
			}
			return new String(output.toByteArray());
		} finally {
			is.close();
		}
	}
}