package edu.ntut.curtain.ws.common;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorOrder;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

import org.codehaus.jackson.map.annotate.JsonSerialize;


@JsonSerialize(include=JsonSerialize.Inclusion.NON_NULL)
@XmlRootElement
@XmlAccessorOrder
@XmlAccessorType(XmlAccessType.FIELD)
public class ResponseMessageHeader {
	
	//順序改為status encoding locale msg
	@XmlAttribute(required = true, name = "status")
	protected String status;
	
	@XmlAttribute(required = true, name = "msg")
	protected String msg;
	
//	@XmlElement(required=true, name="resultset")
//	protected String resultset;
//	
//	public String getResultset() {
//		return resultset;
//	}
//	public void setResultset(String resultset) {
//		this.resultset = resultset;
//	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	
	public String getMsg() {
		return msg;
	}
	public void setMsg(String msg) {
		this.msg = msg;
	}
	
	
}
