package edu.ntut.curtain.ws.common;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorOrder;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

import org.codehaus.jackson.map.annotate.JsonSerialize;

@JsonSerialize(include=JsonSerialize.Inclusion.NON_NULL)
@XmlRootElement
@XmlAccessorOrder
@XmlAccessorType(XmlAccessType.NONE)
public class AnonXml extends ResponseMessageHeader
{

  @XmlElement(required=true, name="resultset")
  @XmlJavaTypeAdapter(ListAdapter.class)
  private List<Object> objects;

  public List<Object> getObjects() {
	  return objects;
  }

  public void setObjects(List<Object> objects) {
	  this.objects = objects;
  }
  
  public void clear() {
	  objects = null;
  }

}